﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace KinectTD.State_Management
{
 public   abstract class Screen
    {

        private float alpha;

        public float ScreenAlpha
        {
            get { return alpha; }
            set { alpha = value; }
        }

        protected Texture2D backgroundImage;

        public Texture2D BackgroundImage
        {
            get { return backgroundImage; }
            set { backgroundImage = value; }
        }
        
        

        private int screenWidth;
        private int screenHeight;
       
        public int Width { get { return screenWidth; } }
        public int Height { get { return screenHeight; } }

        public Screen(int width, int height)
        {
            screenWidth = width;
            screenHeight = height;
            alpha = 1;
        }

        public virtual void Initialise(ContentManager Content)
        {

            LoadContent(Content);
        }

        protected abstract void LoadContent(ContentManager Content);


        public abstract void Update(GameTime gameTime);


        public abstract void Draw(SpriteBatch spriteBatch);

    }
}
