﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content;
namespace KinectTD.UI
{
   public abstract class Control
    {
        protected Vector2 position;
        protected Vector2 size;

        protected Color colour;

        public Vector2 Position
        {
            get { return position; }
            set { position = value; }
        }

        public Vector2 Size
        {
            get { return size; }
            set { size = value; }
        }



        public Color Colour
        {
            get { return colour; }
            set { colour = value; }
        }

        protected Rectangle drawRectangle
        {
            get { return new Rectangle((int)position.X, (int)position.Y, (int)size.X, (int)size.Y); }
        }


        public Control()
        {
            position = Vector2.Zero;
            size = Vector2.Zero;
         
            colour = Color.White;
        }

        public abstract void LoadContent(ContentManager Content);
        public abstract void Draw(SpriteBatch spriteBatch);
      
    }
}
